public class Matrix {
    static final int SIZE = 300;

	public static void main(String args[]) {
		int n = Integer.parseInt(args[0]);

		int A[][] = new int[SIZE][SIZE];
		int B[][] = new int[SIZE][SIZE];
		int C[][] = new int[SIZE][SIZE];
        int X[] = new int[SIZE];
		int Y[] = new int[SIZE];
        int i, j, k, l;

		for (l=0; l<n; l++) {

			/* initialization */
			for (i=0; i<SIZE; ++i) {
				X[i] = Y[i] = 2;
				for (j=0; j<SIZE; ++j) {
					A[i][j] = B[i][j] = C[i][j] = 2;
				}
			}

			/* 5-pointed system */
			for (i=1; i<SIZE-1; ++i)
				for(j=1; j<SIZE-1; ++j)
					A[i][j] = (4*A[i][j] + A[i-1][j] + A[i+1][j]
								+ A[i][j-1] + A[i][j+1])/8;

			/* 9-pointed system */
			for (i=1; i<SIZE-1; ++i)
				for (j=1; j<SIZE-1; ++j)
					A[i][j] = (8*A[i][j] + A[i-1][j] + A[i+1][j]
								+ A[i][j-1] + A[i][j+1] + A[i-1][j+1]
								+ A[i+1][j+1] + A[i-1][j-1]
								+ A[i+1][j-1])/16;

			/* Matrix-Vector Multiply */
			for (i=0; i<SIZE; ++i)
				for (j=0; j<SIZE; ++j)
					Y[i] += A[i][j] * X[j];

			/* Matrix-Matrix Multiply */
			for (i=0; i<SIZE; ++i)
				for (j=0; j<SIZE; ++j)
					for (k=0; k<SIZE; ++k)
						C[i][j] += A[i][k] * B[k][j];

		}

		System.out.print(Y[2]);
		System.out.print(" ");
		System.out.print(C[2][3]);
		System.out.println();
    }

}
